#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <memory.h>
#include <string.h>

#include "HashTable.h"

// Hash Function
Index hashFunction(const char *str)
{
	Index idx = 0;
	const char *ptr = NULL;
	int val = 0;
	ptr = str;

	while (*ptr != '\0') {
		int tmp;
		val = (val << 4) + (*ptr);
		if (tmp = (val & 0xf0000000)) {
			val = val ^ (tmp >> 24);
			val = val ^ tmp;
		}
		ptr++;
	}
	idx = val % TABLE_SIZE;

	return idx;
}

// Init the hash table
void initTable(HashTable *table)
{
	int i = 0;
	assert(table != NULL);

	// Set all the entries of the table as empty
	for (i = 0; i < TABLE_SIZE; i++) {
		table->hashTable[i] = NULL;
		table->sizes[i] = 0;
	}
}

// Destroy all the contents of the table
void destroyTable(HashTable * table)
{
	int i = 0;
	for (i = 0; i < TABLE_SIZE; ++i) {
		// Delete all the lists of the hash table
		if (table->hashTable[i] != NULL) {
			HashEntry *node = table->hashTable[i];
			HashEntry *next = node->next;
			while (node != NULL) {
				next = node->next;
				destroyStudent(&node->student);
				free(node);
				node = next;
			}
		}
	}
	
}




// Insert an entry into the hash table
void insertEntry(HashTable *table, Student *student)
{	
}

// Find a student in the hash table
HashEntry *findEntry(HashTable *table, const char *studentID)
{
	return NULL;
}

// Delete an entry from the hash table
void deleteEntry(HashTable *table, const char *studentID)
{
}

