#include <string.h>
#include <stdlib.h>

#include "student.h"

// Initialize a student
void initStudent(Student *student, const char *name, const char *surname, const char *id)
{
	student->firstName = strdup(name);
	student->lastName = strdup(surname);
	student->id = strdup(id);
}

// Delete the information of the student
void destroyStudent(Student *student)
{
	if (student->firstName != NULL) {
		free(student->firstName);
		student->firstName = NULL;
	}
	if (student->lastName != NULL) {
		free(student->lastName);
		student->lastName = NULL;
	}
	if (student->id != NULL) {
		free(student->id);
		student->id = NULL;
	}
}

// Copy the info of one student into another
void copyStudent(Student *src, Student *dest)
{
	dest->firstName = strdup(src->firstName);
	dest->lastName = strdup(src->lastName);
	dest->id = strdup(src->id);
	dest->grade = src->grade;

}