#ifndef __STUDENT_H__
#define __STUDENT_H__

// Storage for a students info
typedef struct _Student {
	char *firstName;
	char *lastName;
	char *id;
	int grade;
} Student;

// Init a student
void initStudent(Student *student, const char *name, const char *surname, const char *id);
// Destroy a student
void destroyStudent(Student *student);
void copyStudent(Student *src, Student *dest);

#endif // __STUDENT_H__